pro colorproductmap, image, lat, lon,colorimage,range,xparameter,dilateNo=dilateNo,validrange=validrange



if keyword_set( validrange ) then begin
  imin = range( 0 )
  imax = range( 1 )
endif else begin
  imin = min( image, max = imax )
endelse

;- set number of samples and lines for warped image

ns = !d.x_size
nl = !d.y_size
if ( !d.flags and 1 ) then begin
  ns = 1280L
  nl = long( float( ns ) * float( !d.y_size ) / float( !d.x_size ) )
endif

;- create resampled byte image
p = convert_coord( lon, lat, /data, /to_normal )
newimage = replicate( 0B, ns, nl )
newimage( p( 0, * ) * ( ns - 1 ), p( 1, * ) * ( nl - 1 ) ) = image
image = 0

;temp=where(newimage eq 1B,tempcount) 
;if tempcount gt 0 then newimage[temp]=2B

;- extract portion of image which fits within map boundaries

x = !x.window * ns
y = !y.window * nl
newimage = temporary( newimage( x(0):x(1), y(0):y(1) ) )

;- compute image offset and size (device coordinates)

p = convert_coord( [ x(0), x(1) ] / float( ns ), [ y(0), y(1) ] / float( nl ), $
  /normal, /to_device )
xoffset = p(0,0)
yoffset = p(1,0)
xsize = p(0,1) - p(0,0)
ysize = p(1,1) - p(1,0)

;- fill holes in resampled image

nxr = 4
nyr = 4
if keyword_set( lowres ) then begin
  nxr = 7
  nyr = 7
  if ( !d.flags and 1 ) then begin
    nxr =5 
    nyr =5
  endif
endif
fill = dilate( newimage, replicate( 1, nxr, nyr ), /gray )
loc = where( ( fill ge 1b ) and ( newimage eq 0 ), count )
if count ge 1 then newimage( loc ) = fill( loc )
fill = 0

;- fill remaining undefined areas of image with the missing value
missing = 0B
loc = where( newimage eq 0B, count )
if ( count ge 1 ) and ( missing gt 0B) then newimage( loc ) = missing

colorimage=newimage
newimage = 0

xparameter=intarr(4)
xparameter(0)= xoffset
xparameter(1)= yoffset
xparameter(2)= xsize
xparameter(3) =ysize

end
